REMARK
/*
Creating database - removing tables
*/
drop table NOTIFY;
drop table CREDITS;
drop table TICKETS;
drop table FLIGHTS;
drop table CARDS;

REMARK
/* 
Creating tables
*/  
CREATE TABLE CARDS
 (CARDNO       NUMBER(3) NOT NULL,
  NAME         VARCHAR2(16),
  STATUS       VARCHAR2(16),
 PRIMARY KEY(CARDNO));


CREATE TABLE FLIGHTS
 (FLIGHTID       VARCHAR2(5) NOT NULL,
  DEPARTURETIME  VARCHAR2(5),
  DEPARTURECITY  VARCHAR2(16),
  ARRIVALCITY    VARCHAR2(16),
  MILES          NUMBER(5),
 PRIMARY KEY(FLIGHTID));


CREATE TABLE TICKETS
 (TICKETID     VARCHAR2(3) NOT NULL,
  FLIGHTID     VARCHAR2(5),
  FLIGHTDATE   DATE,
  NAME         VARCHAR2(16),
  CARDNO       NUMBER(3),
 PRIMARY KEY(TICKETID),
 FOREIGN KEY(CARDNO) REFERENCES CARDS(CARDNO) ON DELETE SET NULL,
 FOREIGN KEY(FLIGHTID) REFERENCES FLIGHTS(FLIGHTID) ON DELETE CASCADE);


CREATE TABLE CREDITS
 (TICKETID    VARCHAR2(3) NOT NULL,
  CARDNO      NUMBER(3),
  MILES       NUMBER(5),
  PRIMARY KEY(TICKETID),
  FOREIGN KEY(TICKETID) REFERENCES TICKETS(TICKETID) ON DELETE CASCADE,
  FOREIGN KEY(CARDNO) REFERENCES CARDS(CARDNO) ON DELETE CASCADE);


CREATE TABLE NOTIFY
 (CARDNO      NUMBER(3) NOT NULL,
  NOTIFYNO    NUMBER(1) NOT NULL,
  NOTIFYDATE  DATE,
  OLDSTATUS   VARCHAR2(16),
  NEWSTATUS   VARCHAR2(16),
  TOTALMILES  NUMBER(7),
  PRIMARY KEY(CARDNO,NOTIFYNO),
  FOREIGN KEY(CARDNO) REFERENCES CARDS(CARDNO) ON DELETE CASCADE);



REMARK
/*
Inserting data into tables.
*/

INSERT INTO CARDS (CARDNO, NAME, STATUS)
       VALUES (10, 'JOHN', 'SILVER');

INSERT INTO CARDS (CARDNO, NAME, STATUS)
       VALUES (20, 'KEN', 'GOLD');

INSERT INTO CARDS (CARDNO, NAME, STATUS)
       VALUES (30, 'LUCY', 'PREMIUM');

INSERT INTO CARDS (CARDNO, NAME, STATUS)
       VALUES (40, 'BRUCE', 'SILVER');

INSERT INTO CARDS (CARDNO, NAME, STATUS)
       VALUES (50, 'BILL', 'SILVER');


INSERT INTO FLIGHTS (FLIGHTID, DEPARTURETIME, DEPARTURECITY, ARRIVALCITY, MILES)
       VALUES ('RN12K', '00:45', 'ROME', 'NEW YORK', 12000);
       
INSERT INTO FLIGHTS (FLIGHTID, DEPARTURETIME, DEPARTURECITY, ARRIVALCITY, MILES)
       VALUES ('BT18K', '12:34', 'BERLIN', 'TOKYO', 18000);

INSERT INTO FLIGHTS (FLIGHTID, DEPARTURETIME, DEPARTURECITY, ARRIVALCITY, MILES)
       VALUES ('PS22K', '23:59', 'PARIS', 'SIDNEY', 22000);

INSERT INTO FLIGHTS (FLIGHTID, DEPARTURETIME, DEPARTURECITY, ARRIVALCITY, MILES)
       VALUES ('LT08K', '23:59', 'LONDON', 'TORONTO', 8000);

INSERT INTO FLIGHTS (FLIGHTID, DEPARTURETIME, DEPARTURECITY, ARRIVALCITY, MILES)
       VALUES ('TS01K', '11:00', 'TURIN', 'S.MARIA DI LEUCA', 1000);


INSERT INTO TICKETS (TICKETID, FLIGHTID, FLIGHTDATE, NAME, CARDNO)
       VALUES ('T01', 'LT08K', '01-APR-07', 'JOHN', 10);

INSERT INTO CREDITS (TICKETID, CARDNO, MILES)
       VALUES ('T01', 10, 8000);

/*       
INSERT INTO NOTIFY (CARDNO, NOTIFYNO, NOTIFYDATE, OLDSTATUS, NEWSTATUS, TOTALMILES)
       VALUES (10, 1, '01-APR-07', 'SILVER', 'SILVER', 8000);
*/
